-- *********************************************
-- * Standard SQL generation                   *
-- *-------------------------------------------*
-- * Generator date:  Apr 14 2003              *
-- * Generation date: Sun Mar 22 17:17:41 2009 *
-- *********************************************


-- Database Section
-- ________________

create database Assurance;


-- DBSpace Section
-- _______________

create dbspace SP_CLIENT;

create dbspace SP_VEHICULE;


-- Table Section
-- _____________

create table ACCIDENT (
     NUMACC char(10) not null,
     DATEACC date not null,
     MONTANT numeric(6),
     primary key (NUMACC))
     in SP_VEHICULE;

create table CLIENT (
     NUMCLIENT char(12) not null,
     NOM char(38) not null,
     ADRESSE char(60) not null,
     primary key (NUMCLIENT))
     in SP_CLIENT;

create table CONTRAT (
     SIGNATAIRE char(12) not null,
     NUMCTR numeric(4) not null,
     TYPE char(12) not null,
     DATESIGN date not null,
     primary key (SIGNATAIRE, NUMCTR))
     in SP_CLIENT;

create table IMPLICATION (
     NUMACC char(10) not null,
     NUMVEH char(16) not null,
     primary key (NUMACC, NUMVEH))
     in SP_VEHICULE;

create table VEHICULE (
     NUMVEH char(16) not null,
     MARQUE char(30) not null,
     MODELE char(30) not null,
     ANNEE numeric(4) not null,
     CYLINDREE numeric(6) not null,
     SIGNATAIRE char(12) not null,
     NUMCTR numeric(4) not null,
     NUMCLIENT char(12) not null,
     primary key (NUMVEH),
     unique (SIGNATAIRE, NUMCTR))
     in SP_VEHICULE;


-- Constraints Section
-- ___________________

alter table CONTRAT add constraint FKSIGNE|_1
     foreign key (SIGNATAIRE)
     references CLIENT;

alter table IMPLICATION add constraint FKIMP_VEH
     foreign key (NUMVEH)
     references VEHICULE;

alter table IMPLICATION add constraint FKIMP_ACC
     foreign key (NUMACC)
     references ACCIDENT;

alter table VEHICULE add constraint FKCOUVRE|_1
     foreign key (SIGNATAIRE, NUMCTR)
     references CONTRAT;

alter table VEHICULE add constraint FKAPPARTIENT|_1
     foreign key (NUMCLIENT)
     references CLIENT;


-- Index Section
-- _____________

create unique index IDACCIDENT|2_1
     on ACCIDENT (NUMACC);

create unique index ID CLIENT |2_1
     on CLIENT (NUMCLIENT);

create unique index IDCONTRAT|2_1
     on CONTRAT (SIGNATAIRE, NUMCTR);

create unique index IDIMPLIQUE|_1
     on IMPLICATION (NUMACC, NUMVEH);

create index FKIMP_VEH
     on IMPLICATION (NUMVEH);

create unique index IDVEHICULE|2_1
     on VEHICULE (NUMVEH);

create unique index FKCOUVRE|_1
     on VEHICULE (SIGNATAIRE, NUMCTR);

create index FKAPPARTIENT|_1
     on VEHICULE (NUMCLIENT);

